#!/usr/bin/perl

require 'conf.pl';

# Get at environment variable.
$ip = $ENV{'REMOTE_ADDR'};
$rhost = gethostbyaddr(pack("C4", split(/\./, $ip)), 2);
if ($rhost eq '') {
$rhost = $ENV{'REMOTE_HOST'};
}
$bro = $ENV{'HTTP_USER_AGENT'};
$link = $ENV{'HTTP_REFERER'};
($sec, $fun, $hour, $mday, $mon, $year, $zz, $xx, $cc) = localtime(time);
$mon++; $year = $year + 1900;

if ($mon == 1) { $mon = "Jan"; }
if ($mon == 2) { $mon = "Feb"; }
if ($mon == 3) { $mon = "Mar"; }
if ($mon == 4) { $mon = "Apr"; }
if ($mon == 5) { $mon = "May"; }
if ($mon == 6) { $mon = "Jun"; }
if ($mon == 7) { $mon = "Jul"; }
if ($mon == 8) { $mon = "Aug"; }
if ($mon == 9) { $mon = "Sep"; }
if ($mon == 10) { $mon = "Oct"; }
if ($mon == 11) { $mon = "Nov"; }
if ($mon == 12) { $mon = "Dec"; }

# The size of the image of a number is got at $image_size_x and $image_size_y.
open(SIZE, ">$counter_dir/size.fly");
flock(SIZE, 2);
print SIZE "existing $image_dir/0.gif\n";
print SIZE "sizex\n";
print SIZE "sizey\n";
flock(SIZE, 8);
close(SIZE);

open(OUT, "$fly -i $counter_dir/size.fly -o $counter_dir/size.temp |");
while(<OUT>)
{
($image_size_x) = /is\ (\d+)$/ if /Size\ -\ X/;
($image_size_y) = /is\ (\d+)$/ if /Size\ -\ Y/;
}
close(OUT);

open(IN, "$counter_dir/ipa-file.txt");
$temp = <IN>;
close(IN);

@data = split(/ /, $temp);

# If the date has changed, the file which is recording the IP address will be deleted.
if (-e "$counter_dir/ipa-file.txt") {
if ($data[0] != $mday || $data[1] != $mon || $data[2] != $year) {
unlink("$counter_dir/$data[0]-$data[1]-$data[2].txt");
}
}

$check = 0;
if ($reload != 0) {
if (-e "$counter_dir/$mday-$mon-$year.txt") {
open(IN, "$counter_dir/$mday-$mon-$year.txt");
while (<IN>) {
$temp = $_;
chop($temp);
if ($ip eq $temp) {
$check = 1;
}
}
close(IN);
}
}

# Count up
if (!open(IN, "$counter_dir/count.txt")) {
exit(0);
} else {
$count = <IN>;
close(IN);
}

if ($check == 0) {

$count++;

open(OUT, ">$counter_dir/count.txt");
flock(OUT, 2);
print OUT $count;
flock(OUT, 8);
close(OUT);

# An IP address is recorded in order to prevent counting up by reloading.
open(OUT, ">>$counter_dir/$mday-$mon-$year.txt");
flock(OUT, 2);
print OUT "$ip\n";
flock(OUT, 8);
close(OUT);

open(OUT, ">$counter_dir/ipa-file.txt");
flock(OUT, 2);
print OUT "$mday $mon $year \n";
flock(OUT, 8);
close(OUT);

}

# The digit number of a counter is got at $k.
$k = 0;$kk = 1;
while ($count >= $kk) {
$k++;$kk = $kk * $radix;
}

# The number of each digit is got at array $digit.
for ($i = 1;$i <= $k;$i++) {
$kk = $kk / $radix;
$digit[$i] = int(($count - $accum) / $kk);
$accum = $accum + $digit[$i] * $kk;
}

$image_size_xx = $image_size_x * $k;

print "Content-type: image/gif\n\n";

open(FLY, ">$counter_dir/counter.fly");
flock(FLY, 2);
print FLY "new\n";
print FLY "size $image_size_xx,$image_size_y\n";
for ($i = 1; $i <= $k; $i++) {
$x = $image_size_x * ($i - 1);
print FLY "copy $x,0,-1,-1,-1,-1,$image_dir/$digit[$i].gif\n";
}
flock(FLY, 8);
close(FLY);

open(GIF, "$fly -q -i $counter_dir/counter.fly |");
while(<GIF>) {
print;
}
close(GIF);

# Record an access log.
$l = 1;$hostname = "";
if ($rhost ne '') {
$hostname = "(Hostname:$rhost)";
}

if ($logfile != 0) {
if (!open(IN, "$counter_dir/accesslog.txt")) {
open(OUT, ">$counter_dir/accesslog.txt");
print OUT "$mon $mday, $year $hour:$fun:$sec ";
print OUT "IP address:$ip $hostname Browser:$bro URL:$link";
print OUT "\n";
close(OUT);
} else {
open(OUT, ">$counter_dir/accesslog.temp");
print OUT "$mon $mday, $year $hour:$fun:$sec ";
print OUT "IP address:$ip $hostname Browser:$bro URL:$link";
print OUT "\n";
while (<IN>) {
print OUT $_;
$l++;
if ($l == $number_of_log) {
last;
}
}
close(OUT);
unlink("$counter_dir/accesslog.txt");
rename("$counter_dir/accesslog.temp","$counter_dir/accesslog.txt");
}
}

# Delete temporary files.
unlink("$counter_dir/size.temp");
unlink("$counter_dir/size.fly");
unlink("$counter_dir/counter.fly");
